/*  Copyright (C) 2005,2006 Mokrushin I.V. aka McMCC mcmcc@mail.ru

    SERP - Serial EEPROM 24CXX/93CXX programmer on parallel port.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                */
/* ------------------------------------------------------------------------- */

#ifndef _SERP_H
#define _SERP_H

#define VERSION	"0.3(beta)"
#include <time.h>
#ifndef _WINDOWS
#ifdef __FreeBSD__
#include <machine/cpufunc.h>
#include <machine/sysarch.h>
#define out_b(a, b) outb(b, a)
#else
#ifndef WATCOM
#include <sys/io.h>
#define out_b(a, b) outb(a, b)
#else
#include <conio.h>
#define out_b(a, b) outp(b, a)
#define inb(a) inp(a)
/* usleep() not found in Watcom for Linux!!! It's BUG :-( */
static inline void usleep (unsigned long usec)
{
        struct timespec ts;
        ts.tv_sec =  (usec / 1000000);
        ts.tv_nsec = (usec % 1000000) * 1000ul; 
        nanosleep(&ts, NULL);
}
#endif
#endif
#else
#ifdef NO_PORT_TALK
#include <windows.h>
#ifdef _IOPERM
#include <sys/io.h>
#else
#include <conio.h>
typedef short (_stdcall *inpfuncPtr)(short portaddr);
typedef void (_stdcall *oupfuncPtr)(short portaddr, short datum);
inpfuncPtr inp32fp;
oupfuncPtr oup32fp;
HINSTANCE hLib;

static inline short inb(short portaddr)
{
    return (inp32fp)(portaddr);
}

static inline void outb(short datum, short portaddr)
{
    (oup32fp)(portaddr,datum);
}

static inline int lptinit()
{
    hLib = LoadLibrary("inpout32.dll");
    if (hLib == NULL) {
	fprintf(stderr,"LoadLibrary Failed.\n");
	return -1;
    }
    inp32fp = (inpfuncPtr) GetProcAddress(hLib, "Inp32");
    if (inp32fp == NULL) {
        fprintf(stderr,"GetProcAddress for Inp32 Failed.\n");
        return -1;
    }
    oup32fp = (oupfuncPtr) GetProcAddress(hLib, "Out32");
    if (oup32fp == NULL) {
	fprintf(stderr,"GetProcAddress for Oup32 Failed.\n");
        return -1;
    }
    return 0;	  
}

static inline void lptfree()
{
    FreeLibrary(hLib);
}
#endif
#else
#include "pt_ioctl.h"
#endif
#define out_b(a, b) outb(a, b)
#endif

//int LPT = 0x378;
#define LPT 0x378

#ifdef _WINDOWS
#include <largeint.h>
static inline void usleep(int t)
{
   	LARGE_INTEGER Count,EndCount,PerformanceFrequency;
   	QueryPerformanceFrequency(&PerformanceFrequency);
   	QueryPerformanceCounter(&Count);
   	EndCount.QuadPart = Count.QuadPart + (t * PerformanceFrequency.QuadPart * 0.001);
   	while (Count.QuadPart < EndCount.QuadPart) QueryPerformanceCounter(&Count);
}
#endif

#endif
